/* -----------------------------*- Mode: C -*----------------------------- *\
| File:         midi-lib.h                                                  |
| Description:  BOOMS midi-lib header file                                  |
| Author:       Eli Barzilay - eli@cs.bgu.ac.il                             |
| Date:         11-8-95                                                     |
\*-------------------------------------------------------------------------*/

/*

This file is part of the BOOMS system:
+-----------------------------------------------------------------------------+
|                                                                             |
| /######   /#####   /#####  /##     /##  /#####                              |
| /##///## /##///## /##///## /###   /### /##///##                        /--- |
| /##  /## /##  /## /##  /## /#### /#### /##  ///          /------/     /     |
| /######/ /##  /## /##  /## /##/####/## //#####          /      /     /      |
| /##///## /##  /## /##  /## /##//##//##  /////##        /------/ __  /       |
| /##  /## /##  /## /##  /## /## /// /##      /##   __  /  __  / /  \/        |
| /##  /## /##  /## /##  /## /##     /## /##  /##  /  \/  /  \/  \__/         |
| /######/ //#####/ //#####/ /##     /## //#####/  \__/   \__/                |
| ///////   //////   //////  ///     ///  //////                              |
|                                                                             |
|                   Booms Object Oriented Music Structures.                   |
|Eli Barzilay:                                                   Maze is Life!|
+-----------------------------------------------------------------------------+

*/


#include <windows.h>
#include <mmsystem.h>

#define DllExport __declspec ( dllexport )

#define BUFFER_SIZE    6000
#define RESOLUTION     20
#define NIL            (-1)

typedef struct tagEvent {
  DWORD message;
  DWORD time;
  int   next;
} Event;

BOOL  APIENTRY   DllMain(HANDLE hModule, DWORD reason, LPVOID lpReserved);

BOOL  DllExport  play_sound (LPCSTR str);
BOOL  DllExport  midi_open_p();
BOOL  DllExport  midi_open();
BOOL  DllExport  midi_close();
BOOL  DllExport  midi_reset();
BOOL  DllExport  set_volume (WORD volume);
WORD  DllExport  get_volume();
void  DllExport  play_note (DWORD start, UINT duration,
                            char pitch, char velocity);
DWORD DllExport  get_time();
void  DllExport  put_event (DWORD message, DWORD time);
void             activate_timer();
void             deactivate_timer();
TIMECALLBACK     TimerCallBack;
int              get_cell();
void             free_cell (int cell);
BOOL  DllExport  midi_send (DWORD Msg);
void             error (LPCSTR str);

